/*
 * Copyright (c) 2012, Masanori Miyamoto.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * 1.Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * 2.Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 */ 
#ifndef __PARSER_H__
#define __PARSER_H__

#include "lex_analyzer.h"
#include "CzarBasic_vm.h"
#include "CzStream.h"

enum _parse_result {
	PARSE_RESULT_FALSE,	/* 失敗 */
	PARSE_RESULT_TRUE,	/* 成功 */
	PARSE_RESULT_OVERFLOW,	/* 数値オーバーフロー */
	PARSE_RESULT_NOSTATEMENT,	/* ステートメントでない */
};
typedef enum _parse_result PARSE_RESULT;

PARSE_RESULT parser(VM_DATA *vm_data, LEX_DATA *stream);
/* 整数へ変換 */
PARSE_RESULT parse_int(LEX_DATA *stream, int *retval);

/* ラベルの検索 */
UINT32 search_label(VM_DATA *vm_data, char *label);
/* ラベルに割り当てられているアドレスを取得 */
UINT32 get_label_address(VM_DATA *vm_data, UINT32 label_index);

#endif
